//+------------------------------------------------------------------+
//|                                     Margin Level Monitor Utility |
//|                 Copyright 2007  Shinigami - shini1984@gmail.com |
//|                                version 3 overhaul by Azmel Ainul |
//+------------------------------------------------------------------+

#property copyright "Shinigami 2007"
#property link      "shini1984@gmail.com"


extern string EA.Name = "";

double Equity;
double MarginLevel;
double MinMarginLevel;
double Margin;
double MaxMargin;
double MaxProfit;
double Profit;
double MinProfit;
double MinMarginLevelTime;

string line1;
string line2;
string line3;
string line4;
string line5;
string line6;

int init()
{
   MinMarginLevel=GlobalVariableGet("MinMarginLevel");
   MaxMargin=GlobalVariableGet("MaxMargin");
   MinProfit=GlobalVariableGet("MinProfit");
   MinMarginLevelTime=GlobalVariableGet("MinMarginLevelTime");
   return(0);
}

int start()
{
   Margin=AccountMargin();
   Profit=AccountProfit();
   Equity=AccountEquity();
   line1=StringConcatenate("EA Name                      : ",EA.Name);
   if(Margin==0)
   {
      line2="Current Margin Level       : IDLE";
   }
   else
   {
      MarginLevel=Equity/Margin;
      line2=StringConcatenate("Current Margin Level       : ",MathFloor(MarginLevel*100),"%");
      if(MinMarginLevel==0 || MarginLevel<MinMarginLevel)
      {
         MinMarginLevel=MarginLevel;
         MaxMargin=Margin;
         MinProfit=Profit;
         MinMarginLevelTime=CurTime();
         GlobalVariableSet("MinMarginLevel",MinMarginLevel);
         GlobalVariableSet("MaxMargin",MaxMargin);
         GlobalVariableSet("MinProfit",MinProfit);
         GlobalVariableSet("MinMarginLevelTime",MinMarginLevelTime);
      }
   }
   if(MinMarginLevel==0)
   {
      line3="Minimum Margin Level     : NIL";
      line4="Date and Time of incident: NIL";
      line5="Margin value at incident   : NIL";
      line6="Profit value at incident     : NIL";
   }
   else
   {
      line3=StringConcatenate("Minimum Margin Level     : ",MathFloor(MinMarginLevel*100),"%");
      line4=StringConcatenate("Date and Time of incident: ",TimeToStr(MinMarginLevelTime));
      line5=StringConcatenate("Margin value at incident   : ",MaxMargin);
      line6=StringConcatenate("Profit value at incident     : ",MinProfit);
   }
   Comment("\n\n\n\n\n\n\n\n\n\n",
           "  ",line1,"\n",
           "  ",line2,"\n",
           "  ",line3,"\n",
           "  ",line4,"\n",
           "  ",line5,"\n",
           "  ",line6);

   return(0);
}